uniform float u_beg;

// pöllitty!
float smin( float a, float b, float k )
{
	float h = clamp( 0.5+0.5*(b-a)/k, 0.0, 1.0 );
	return mix( b, a, h ) - k*h*(1.0-h);
}


float amp(float x)
{
	float zin  = sin(pow(x, 0.5) * 3.4);

	zin = pow(zin, 5.0) * 1.0;
	return zin;
}

float ft;

float wave(float x)
{
	float zin = 0.0;
	
	const float harms = 12.0;
	for (float i = 0.0; i <= harms; i++)
	{
		float hpos = i / harms;
		float p = 3.0 + i + ft * 4.15 * (sin(09.59 * hpos) + 0.9);
		float a = amp(hpos) * 0.4;
	 //   a = 1.0;
		zin += sin(x * (9.5) * i + p) * a;
	}
	zin *= 0.05;
	return zin;
	
}

void city(inout vec4 fragColor, vec2 uv, float ft)
{

	float mover = 0.5 + sin(ft * 2.1234) * 0.5;
	
	vec2 skypos = vec2(0.0);
	skypos += sin(vec2(ft) * vec2(9.321,10.7321)) * 0.6 * mover;
	skypos += sin(vec2(ft) * vec2(18.521,20.61)) * 0.4 * mover * mover;
	skypos += sin(vec2(ft) * vec2(19.121,21.1261)) * 0.3 * mover * mover;
	skypos += sin(vec2(ft) * vec2(4.721,5.3321)) * 0.9;      
	skypos *= 0.003;
	//skypos += texture2D(iChannel0, vec2(ft) * vec2(0.03421,0.0452)).gb * 0.01;
	skypos.x += ft * 0.1 + sin(ft*13.41) * 0.002;

	skypos *= 0.7;
	
	float cityp = (uv.x+ skypos.x) * 12.0;
	cityp+=cos(cityp)*0.4 + sin(cityp*5.31)*0.2;
	float bi = floor(cityp);
	float bh = 0.75+sin(bi * 4.39123) * 0.1 + cos(bi*5.2412) * 0.05 - skypos.y;
	bh += sin(bi*5.2523) * fract(cityp) * 0.015;
	if (bh > uv.y)
	{
		float shitytex = texture2D(u_blurnoise, (uv2 + skypos) * 0.1).r * max(0.0, uv.y - 0.45) * 0.7;
	   fragColor = texture2D(u_blurnoise, uv2 + vec2(ft*0.2432+bi*0.2123, 0.0+bi*0.3)) * 1.0 * shitytex ;
	 
		fragColor += vec4(shitytex * 1.0);
		fragColor = fragColor.rrrr * 0.3;
	}    

	
}

vec4 sky(vec2 uv, float ft)
{
	vec2 uvb = uv;
	 uvb += dot(sin(uv.yx * 41.0 + vec2(ft)*vec2(1.34,1.251)) * 0.03, vec2(1.0));
	uvb += dot(sin(uv.yx * 20.0 - vec2(ft)*vec2(1.22,1.45)) * 0.03, vec2(1.0));
	vec4 fragColor = normalize(vec4(uvb.y, 0.1+sin(uvb.y * 20.1)*0.1, 1.0-uvb.y, 0.0));
	
	float skyglow = 0.9 + sin(ft * 9.322) * 0.03;
	skyglow += sin(ft * 17.213) * 0.05;
	fragColor *= min(1.0, (1.0 - uv.y) * 1.0 * skyglow);

	fragColor *= texture2D(u_blurnoise, (uv2+vec2(ft*0.1,0.0))*0.01).ggrr * 2.0;

		fragColor = mix(fragColor, fragColor * vec4(0.4,0.6,0.2,0.0), smoothstep(1.0, 0.97, length(uv2) ));
	
	vec4 fc = vec4(1.0);
	city(fc, uv + vec2(-0.02,0.03), ft);
	fragColor *= fc * 0.4 + vec4(0.6);
	fragColor *= 2.0;
	city(fragColor, uv, ft);

	fragColor = clamp(fragColor, vec4(0.0), vec4(1.0));

	return fragColor;
}

vec4 function()
{
	ft = motionblur(2.0) - u_beg;
//    t -= texture2D(iChannel0, uv * 1.0).r * 0.03;
	
	vec4 fragColor;
	
//    uv.x += cos(ft * 15.2) * 0.001;
//    uv.y += sin(ft * 12.2) * 0.0016;


	fragColor = vec4(0.0, 1.0, 0.0, 0.0);

		float zin;
	zin = wave(uv.x) * 0.4 + 0.5;
	//zin = amp(uv.x);
	float py = uv.y;
   
	if (py < zin)
	{    
		fragColor += vec4(0.9);
		fragColor = clamp(fragColor, vec4(0.0), vec4(1.0));
		fragColor *= vec4(0.4,0.8 - uv.y,1.0,0.0);
		
		fragColor *= pow(min((zin-py) * 1.4, 1.0), 1.0);
		

		float zet = (40.0 - uv.y * 80.0);

		vec2 buv = uv + (texture2D(u_blurnoise, uv).gb - vec2(0.5)) * max(0.0, 0.1-uv.y*0.3);
			   vec2 uvx = buv;
		uvx.x -= 0.5;
	uvx.x *= 20.0 / zet;
	uvx.x += ft * 0.2;
	uvx.x += 0.5;
		uvx.y += zin * 0.2;
		
		vec2 suv = vec2(buv.x,1.0-buv.y+zin*0.2-0.1);

		fragColor *= min(1.0, texture2D(u_blurnoise, uvx * 0.03).r *0.3+0.7);
		
		fragColor *= 1.2;
		
		float reflec = 1.0;//texture2D(iChannel1, uvx*0.3).b * 5.0;
		fragColor += sky(suv, ft) * 0.4 * reflec;

	  //  bh = 1.0 - bh - zin * 0.12;
	 //   if (bh < uv.y)
	   //     fragColor *= 0.8;
	}
	else
	{
		vec2 buv = uv + texture2D(u_blurnoise, uv).gb * 0.009;
		fragColor = sky(buv, ft);
	}

	
	mat3 rgbtoyuv = mat3(0.299, -0.147,  0.615, 0.587, -0.289, -0.515, 0.114, 0.436, -0.100);
	mat3 yuvtorgb = mat3(1.000, 1.000, 1.000, 0.000, -0.395, 2.032, 1.140, -0.581, 0.000);



	float usa = mod(dot(uv2,vec2(6.0+sin(uv2.y+ft),1.0))-ft*0.787, 5.0);
	float segment = floor(usa);
	float inside = fract(usa);
	float fix = smoothstep(5.0, 1.6, ft);
	float fixc = smoothstep(5.0, 2.5, ft);
	vec4 usac;
	if (segment == 0.0)
	{
		vec2 uvs = mod(uv2 * vec2(1.2,1.7) + vec2(-0.1,-0.1)*ft, vec2(0.27,0.47)) + vec2(0.28);
		usac = texture2D(iChannel1, uvs);
	}
	else if (mod(segment, 2.0) == 0.0)
	{
		usac = vec4(1.0, 0.0, 0.0, 0.0);
	}
	else if (mod(segment, 2.0) == 1.0)
	{
		usac = vec4(1.0);
	}

	float cc = sin(uv2.y+ft) * -0.05;

	usac *= 0.1 + fixc + fragColor * 0.1 + cc;

	fragColor = mix(fragColor, usac, step(fix, inside)*0.8);

//	float fix2 = smoothstep(10.0, 6.0, ft) * 3.0;

  

  #if 0
	fragColor.rgb = rgbtoyuv * fragColor.rgb;
//    fragColor.r *= 1.0 / (1.0 + length((uv - vec2(0.5)) * 1.0) * 1.0);
//    fragColor.r = pow(fragColor.r, 0.5) * 1.0;
	fragColor.gb *= 0.5;
	fragColor.r *= 0.8+texture2D(u_blurnoise, uv * 1.923+sin(ft*vec2(92.212,3.212))).r*0.2;
	fragColor.rgb = yuvtorgb * fragColor.rgb;
	#endif

	vec4 logo = texture2D(iChannel0, uv2 * vec2(0.35, 0.5) + vec2(0.5));

	vec3 lcol = mix(vec3(1.0, 0.3, 0.1), vec3(0.3, 0.5, 1.0), uv2.y*6.0 + 0.5);
	lcol = mix(vec3(1.0), lcol, clamp(uv2.y*16.0 + 1.9, 0.0, 1.0));
	float dpm = logo.r;
//    dpm = min(dpm, max(0.0, (dot(uv2, vec2(-0.15, 1.0)) + 0.4)*2.0));
//    dpm = min(dpm, max(0.0, (-dot(uv2, vec2(-0.15, 1.0)) + 0.3)*2.0));
	fragColor.rgb = mix(fragColor.rgb, lcol, dpm);



	fragColor.rgb = mix(fragColor.rgb, vec3(0.0), logo.b);

	vec3 logogrit = texture2D(u_blurnoise, uv2 * 0.123).rrr;
	fragColor.rgb = mix(fragColor.rgb, logogrit * vec3(0.2) + vec3(0.2+sin(uv2.y*50.0+uv2.x*20.0+ft*1.0)*0.1), logo.g);

//		fragColor = mix(fragColor, usac, step(2.0, segment));

	vec4 creds = texture2D(iChannel2, uv2 * vec2(0.45,2.0) + vec2(0.5, 2.0));

	fragColor = mix(fragColor, creds, creds.a * smoothstep(4.5, 5.5, ft));

//	fragColor *= length(uvs);

	return fragColor;

//    fragColor = texture2D(iChannel1, uvx);
	
}